import Vue from 'vue'
import Vuex from 'vuex'

/* Store*/
import state from '@/store/state'
import getters from '@/store/getters'
import mutations from '@/store/mutations'
import actions from '@/store/actions'
// modules
import dateModule from '@/store/modules/date'
import currenciesModule from '@/store/modules/currencies'
import journalsModule from '@/store/modules/journals'
import statementModule from '@/store/modules/statement'
import statementConfigModule from '@/store/modules/statementConfig'
import userModule from '@/store/modules/user'
import statementTypeModule from '@/store/modules/statementType'
import resUsersModule from '@/store/modules/resUsers'
//Actions Statement
import statementAction from '@/store/modules/statementAction'

/* Module */
Vue.use(Vuex)

const store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules: {
        dateModule,
        currenciesModule,
        journalsModule,
        statementModule,
        statementConfigModule,
        userModule,
        statementTypeModule,
        resUsersModule,
        statementAction,
    },
    strict: true
})

export default store
