const initialState = {
    isTransfer: false,
    isInputCashbox: false,
    isOutputCashbox: false,
    isStatmentConfirm: false,
    amountOperation: 0,
    description: '',
    // operationTitle: ''
}

const state = {
    isTransfer: initialState.isTransfer,
    isInputCashbox: initialState.isInputCashbox,
    isOutputCashbox: initialState.isOutputCashbox,
    isStatmentConfirm: initialState.isStatmentConfirm,
    amountOperation: initialState.amountOperation,
    description: initialState.description,
    // operationTitle: initialState.operationTitle
}

const getters ={
    isTransfer(state) {
        return state.isTransfer;
    },
    isInputCashbox(state) {
        return  state.isInputCashbox;
    },
    isOutputCashbox(state) {
        return state.isOutputCashbox;
    },
    isStatmentConfirm(state) {
        return state.isStatmentConfirm
    },
    amountOperation(state) {
        return state.amountOperation
    },

    description(state) {
        return state.description
    },
    operationTitle(state){
        if (state.isTransfer) {
            return 'Transferencia interna de cajas'
        }
        if (state.isInputCashbox) {
            return 'Entrada de dinero'
        }
        if (state.isOutputCashbox) {
            return 'Extracciónes de valores'
        }
        if (state.isStatmentConfirm) {
            return 'Cierre de Caja'

        }
    }
}

const mutations = {
    setTransfer(state, payload) {
        state.isTransfer = !!payload
    },
    setInputCashbox(state, payload) {
        state.isInputCashbox = !!payload
    },
    setOutputCashbox(state, payload) {
        state.isOutputCashbox = !!payload
    },
    setStatmentConfirm( state, payload) {
        state.isStatmentConfirm = !!payload
    },

    /* amountOperation */
    setAmountOperation(state, payload) {
        state.amountOperation = payload
    },
    setDescription(state, payload) {
        state.description = payload
    },
}

const actions = {
    clcikTransfer({ commit }, payload) {
        commit('setTransfer', payload)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        commit('setStatmentConfirm', false)
    },
    clickInputCashbox({ commit }, payload) {
        commit('setTransfer', false)
        commit('setInputCashbox', payload)
        commit('setOutputCashbox', false)
        commit('setStatmentConfirm', false)
    },
    clickOutputCashbox({ commit }, payload) {
        commit('setTransfer', false)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', payload)
        commit('setStatmentConfirm', false)
    },
    clcikConfig({ commit, dispatch, getters },payload) {
        commit('setStatmentConfirm', payload)
        commit('setTransfer', false)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        /* Change amount operation */
        dispatch('changeAmountOperation',getters.amountStatementOrigin)
    },
    /* AmountOperation */
    changeAmountOperation({ commit }, payload) {
        commit('setAmountOperation', payload)
    },

    /* Description */
    changeDescriptionOperation({ commit }, payload){
        commit('setDescription', payload)
    },

    resetStatementAction({ commit }) {
        commit('setTransfer', false)
        commit('setInputCashbox', false)
        commit('setOutputCashbox', false)
        commit('setAmountOperation', 0)
        commit('setDescription', '')
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
